Ext.onReady(function(){
    Ext.QuickTips.init();
	
	var type = Ext.data.Record.create([
   	       {name: 'customer_type'},
		   {name: 'customer_type'}
    ]);

 	var typestore = new Ext.data.Store({
			proxy: new Ext.data.HttpProxy
			({
            	url: 'data/getcustomertype.php', 
				success: function(response,options){
                	var json = Ext.util.JSON.decode(response.responseText);
            	} 
       		}),
        reader: new Ext.data.JsonReader({
			root: 'rows1',
			id: 'customer_type',
			labelField:'customer_type'
		},type)
	});
	
	typestore.load();
	
 	 var xg = Ext.grid;
	 
	 var sm2 = new xg.CheckboxSelectionModel({
        listeners: {
        selectionchange: function(sm) {
                if (sm.getCount()) {
                    grid.removeButton.enable();
                } else {
                    grid.removeButton.disable();
                }
            }
        }
    });  
	 
	var encode = false;
	var local = false;
	
	function confirmdeleteSchool(){
		if(grid.selModel.getCount() == 1)
		{
		  Ext.MessageBox.confirm('Confirmation','You are about to delete a Product. Continue?', deleteSchool);
		} else if(grid.selModel.getCount() > 1){
		  Ext.MessageBox.confirm('Confirmation','Delete these Product(s)?', deleteSchool);
		} 
  } 
function deleteSchool(btn){
    if(btn=='yes'){
         var selections = grid.selModel.getSelections();
         var prez = [];
         for(i = 0; i< grid.selModel.getCount(); i++){
          prez.push(selections[i].json.customer_id);
         }
         var encoded_array = Ext.encode(prez);
		
         Ext.Ajax.request({  
            waitMsg: 'Please Wait',
            url:'data/customer-grid-delete.php', 
            params: { 
               task: "DELETEEMP", 
               ids:  encoded_array
			   }, 
            success: function(response){
              var result=eval(response.responseText);
              switch(result){
              case 1: 
			  	store.reload();
                break;
              default:
                Ext.MessageBox.alert('Warning','Could not delete the entire selection.');
                break;
              }
            },
            failure: function(response){
              var result=response.responseText;
              Ext.MessageBox.alert('error','could not connect to the database. retry later');      
              }
         });
      }  
  }
  
store = new Ext.data.JsonStore({
       	autoDestroy: true,
        url:'data/customer-grid-filter.php',
        remoteSort: true,
        sortInfo: {
            field: 'customer_id',
            direction: 'ASC'
        },        
        idProperty: 'customer_id',
        root: 'data',
        totalProperty: 'total',
        fields: [{
            name: 'customer_id',
			type: 'int'
        }, {
            name: 'customer_name'
        }, {
            name: 'contactperson1'
        }, {
            name: 'contactperson_mobileno1'
        }, {
            name: 'customer_type'
        }, {
            name: 'customer_phone1',
			type: 'int'
        }, {
            name: 'customer_address',
			type: 'string'
        }
		] 
    });
var filters = new Ext.ux.grid.GridFilters({
        encode: encode,
        local: false,                                      
		filters: [{
				  type: 'numeric',
            dataIndex: 'customer_id',
			 phpMode: true
        }, {
			type: 'string',
            dataIndex: 'customer_name',
			phpMode: true

        }, {
			type: 'string',
            dataIndex: 'contactperson1',
			phpMode: true

        },{
			type: 'string',
            dataIndex: 'contactperson_mobileno1',
			phpMode: true

        },{
            dataIndex: 'customer_type',
			type: 'list',
			labelField:'customer_type',
			store : typestore,
            phpMode:true
					
        },{
            dataIndex: 'customer_address',
			type: 'string'
        }, {			
			type: 'string',
            dataIndex: 'customer_phone1',
			//options : ['Yes','No'],
			 phpMode: true
        }]
    });
	
var createColModel = function (finish, start) {
        var columns = [
		sm2,
		{
			header: "Edit",	
			width:35,
		    renderer: function(value, metaData, record, rowIndex, colIndex, store) {
		   		return '<a href="addedit-customer.php?ID='+ record.get('customer_id') +'">Edit</a>';
			}
		},
		{
			width:40,
            dataIndex: 'customer_id',
			header: 'Customer ID',
			hidden:true,
			filterable: true
        }, {
			width:95,
            dataIndex: 'customer_name',
			header: 'Customer Name',
			filterable: true
        },{
			width:165,
            dataIndex: 'customer_address',
			header: 'Address'
        }, {
			width:80,
            dataIndex: 'customer_phone1',
			header: 'Phone No'
			//renderer: rating
        } ,{
			width:60,
            dataIndex: 'customer_type',
			header: 'Type'
        },{
			width:95,
            dataIndex: 'contactperson1',
			header: 'Contact Person'
        },{
			width:80,
            dataIndex: 'contactperson_mobileno1',
			header: 'contact Mobile'
        }];
		return new Ext.grid.ColumnModel({
            columns: columns.slice(start || 0, finish),
            defaults: {
                sortable: true
            }
        });
    };
	
var grid = new Ext.grid.GridPanel({
        store: store,
        colModel: createColModel(40), 
        loadMask: true,
		frame: true,
		enableColLock:false,
		//height: 450,    
       // width: 400,
        layout: 'fit',
		columnLines:true,
    	selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
        plugins: [filters],
		sm: sm2,
        listeners: {
            render: {
                fn: function(){
                    store.reload({
                        params: {
                            start: 0,
                            limit: 10  
                        }
                    });
                }
            }
        }  ,
		tbar:[
         { 
		    	iconCls: 'icon-add',
           		text: 'Add Customer',
				ref: '../removeButton',
            	handler: function() {
               location.href="addedit-customer.php"; }
              
		            
      		},'-',
			{text: 'Delete Customer',
            handler: confirmdeleteSchool,  
            iconCls:'remove',
			ref: '../removeButton',
			disabled: true
			}
	  ], 
        bbar: new Ext.PagingToolbar({
            store: store,
            pageSize: 10,
			displayInfo: true,
            plugins: [filters]
        })
    });

    grid.getBottomToolbar().add([
        '->',
      {
            text: 'Clear Filter Data',
            handler: function () {
                grid.filters.clearFilters();
            } 
        }    
    ]);
	
	store.on({
		'beforeload': {
    		fn: function(store, options){
            	options.params || (options.params = {}); 
            	Ext.apply(options.params, {
            		pageNo: this.pageNumber
            	});
        	},
        	scope: this
    	}
	});
	
	grid.on('render', function() {
    grid.tip = new Ext.ToolTip({
    view: grid.getView(),
    target: grid.getView().mainBody,
    delegate: '.x-grid3-row',
    trackMouse: true,
    anchor: 'top',
   renderTo: document.body,
    listeners: {
     beforeshow: function updateTipBody(tip) {
		
	     tip.body.dom.innerHTML = "Click on Edit Link To Edit Record.";
     }
    }
   });
  });
	
	 var SchoolWindow = new Ext.Window({
        title: 'View Customer Information',
        height: 400,
        width: 680,
		modal:true,
		border: false,
        layout: 'fit',
		closeAction:'close',
		collapsible:'true',
        items: grid
    }).show();
	 
	var varWidth =  (screen.width - SchoolWindow.width)/2;
	SchoolWindow.setPosition(varWidth,((screen.height/4)-100));
});